#include <stdio.h>
#include <fcntl.h>

extern char *malloc();

main(argc, argv)        /* file preallocator */
int argc;
char *argv[];
{
        char *buffer;
        long subtotal_bytes, filesize, bufsize;
	int fd, result;

        if (argc != 4) {
        	printf("Usage: %s filename filesize bufsize\n", argv[0]);
        	exit(1);
        }
        filesize = howmuch(argv[2]);
        bufsize = howmuch(argv[3]);
        
        if ((buffer = malloc(bufsize)) == (char *)NULL)
            error_message(argv[0],"malloc failed");

        if ((fd = open(argv[1], O_WRONLY | O_CREAT | O_TRUNC, 0666)) < 0)
                error_message(argv[0],"can't open file");

        subtotal_bytes = 0;
        while (subtotal_bytes < filesize) {
        	result = write(fd,buffer,bufsize);
        	if (result != bufsize) error_message(argv[0],"bad write");
        	subtotal_bytes += result;
        }
	close(fd);
}
