/* iomessages.h
/* Copyright (c) 1988, Prime Computer, Inc., Natick, MA 01760
/*                     All Rights Reserved
*/

/* This file defines the IPC message facilities used by IOBENCH.

   Initial Version:     19 May 1989 by Barry Wolman
*/


#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

#define INKEY      75        /* Arbitrary keys, change as needed */
#define OUTKEY     76

#define MSGITEMS   4         /* Number of items in a message */

struct msgstruct {
        long    mtype;
        long    mitem[MSGITEMS];
        };

#define RECEIVE(q,x,y) msgrcv(q,&x,sizeof(x.mitem),y,0)

#define SEND(q,x) msgsnd(q,&x,sizeof(x.mitem),0)
